import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 *The ball will roll and hit the pins and add points.
 * 
 * @author (Ryan Cooke) 
 * @version (5/20/19)
 */

/**
 * Add score
 */
public class Ball extends Actor
{
    public int score;
    
    public Ball()
    {
        score = 0;
    }
    
    /**
     * Return the score.
     */
    public int getScore()
    {
        return score;
    }
    
    /**
     * keep the score of the game
     */
    public void setScore()
    {
        score = score +1;
    }
    
    /**
     * Act - do whatever the Ball wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
       checkCollision();
       checkKeyPress("B", ",", ".");
       isAtBack();
    } 
    
    /**
     * If the ball hits a pin, it will knock the pin over.
     */
    public void checkCollision()
    {
        if( isTouching(Pin.class))
        {
            setScore();
            removeTouching(Pin.class);
        }
    }
    
    
    /**
     * Check whether a control key on the key baord has been pressed,
     * If so release ball.
     */
    public void checkKeyPress(String right, String up, String down)
    {
        if (Greenfoot.isKeyDown(right))
        {
            move(5);
        }
        if (Greenfoot.isKeyDown(up))
        {
            setLocation(getX(), getY()-2);
        }
        if (Greenfoot.isKeyDown(down))
        {
            setLocation(getX(),getY()+2);
        }
    }
    
    /**
     * When the ball touches the edge, it will go back to the line
     */
    public void isAtBack()
    {
        if (isAtEdge())
        {
            setLocation(84, 197);
            Greenfoot.stop();
        }
    }
}
